#include "../linear_algebra.h"

void la_backward_solve(const double lu[],
                       const double ux[],
                       double x[],
                       int n) {
  if (x != ux) {
    for (int k = 0; k < n; k++) {
      x[k] = ux[k];
    }
  }
  for (int k = n - 1; k > -1; k--) {
    double u_k_k = lu[k * n + k];
    double x_k = x[k] / u_k_k;
    x[k] = x_k;
    for (int i = 0; i < k; i++) {
      x[i] -= lu[i * n + k] * x_k;
    }
  }
}
