#include "../linear_algebra.h"

void la_backward_solve_transposed(const int p[],
                                  const double lu[],
                                  double c[],
                                  double y[],
                                  int n) {
  for (int k = n - 1; k > -1; k--) {
    double c_k = c[k];
    for (int j = 0; j < k; j++) {
      c[j] -= c_k * lu[k * n + j];
    }
  }
  for (int k = 0; k < n; k++) {
    y[p[k]] = c[k];
  }
}
