#include <math.h>
#include "../linear_algebra.h"

void la_factor(const double a[], int p[], double lu[], int n) {
  for (int k = 0; k < n; k++) {
    p[k] = k;
  }
  for (int k = 0; k < n * n; k++) {
    lu[k] = a[k];
  }
  for (int k = 0; k < n; k++) {
    int s = k;
    double fabs_lu_s_k = fabs(lu[s * n + k]);
    for (int i = k + 1; i < n; i++) {
      double fabs_lu_i_k = fabs(lu[i * n + k]);
      if (fabs_lu_i_k > fabs_lu_s_k) {
        s = i;
        fabs_lu_s_k = fabs_lu_i_k;
      }
    }
    if (s != k) {
      int p_k = p[k];
      p[k] = p[s];
      p[s] = p_k;
      for (int j = 0; j < n; j++) {
        double lu_k_j = lu[k * n + j];
        lu[k * n + j] = lu[s * n + j];
        lu[s * n + j] = lu_k_j;
      }
    }
    double lu_k_k = lu[k * n + k];
    for (int i = k + 1; i < n; i++) {
      double lu_i_k = lu[i * n + k] / lu_k_k;
      lu[i * n + k] = lu_i_k;
      for (int j = k + 1; j < n; j++) {
        lu[i * n + j] -= lu_i_k * lu[k * n + j];
      }
    }
  }
}
