#include "../linear_algebra.h"

void la_forward_solve_transposed(const double lu[],
                                 const double c[],
                                 double y[],
                                 int n) {
  for (int k = 0; k < n; k++) {
    y[k] = c[k];
  }
  for (int k = 0; k < n; k++) {
    double u_k_k = lu[k * n + k];
    double y_k = y[k] / u_k_k;
    y[k] = y_k;
    for (int j = k + 1; j < n; j++) {
      y[j] -= y_k * lu[k * n + j];
    }
  }
}
