#include <math.h>
#include "../epsilon.h"
#include "../linear_algebra.h"

double la_relative_residual(const double a[],
                            const double b[],
                            const double x[],
                            int n) {
  double norm_b = 0.0, norm_r = 0.0;
  for (int i = 0; i < n; i++) {
    double b_i = b[i];
    double fabs_b_i = fabs(b_i);
    if (fabs_b_i > norm_b) {
      norm_b = fabs_b_i;
    }
    double r_i = b_i - la_dot_product(a + i * n, x, n);
    double fabs_r_i = fabs(r_i);
    if (fabs_r_i > norm_r) {
      norm_r = fabs_r_i;
    }
  }
  return norm_r > epsilon() ? norm_r / norm_b : 0.0;
}
