#include "linear_algebra.h"

#define INPUT(name, dimension)                  \
  static double name[dimension];                \
  la_random(&seed, name, dimension)

enum {
  N = 200
};

int main(void) {
  long unsigned int seed = 1;
  INPUT(a, N * N);
  INPUT(b, N);
  INPUT(c, N);
  static int p[N];
  static double lu[N * N];
  la_factor(a, p, lu, N);
  static double x[N];
  la_solve(p, lu, b, x, N);
  printf("%g\n", la_relative_residual(a, b, x, N));
  static double at[N * N];
  la_transpose(a, at, N);
  static double yp[N], y[N];
  la_solve_transposed(p, lu, b, yp, y, N);
  printf("%g\n", la_relative_residual(at, b, y, N));
}
