#include <stddef.h>
#include "../priority_queue.h"

static struct pq_node *merge(struct pq_node *a, struct pq_node *b) {
  if (b->key < a->key) {
    struct pq_node *c = a;
    a = b;
    b = c;
  }
  b->sibling = a->child;
  a->child = b;
  return a;
}

struct pq_node *pq_pop(struct pq_node *queue) {
  struct pq_node *c = queue->child;
  if (!c) {
    return NULL;
  }
  struct pq_node *b = NULL;
  while (1) {
    struct pq_node *d = c->sibling;
    if (!d) {
      break;
    }
    struct pq_node *e = d->sibling;
    struct pq_node *cd = merge(c, d);
    if (!e) {
      c = cd;
      break;
    }
    cd->sibling = b;
    b = cd;
    c = e;
  }
  while (b) {
    struct pq_node *a = b->sibling;
    c = merge(b, c);
    b = a;
  }
  return c;
}

struct pq_node *pq_push(struct pq_node *queue, struct pq_node *item) {
  item->child = NULL;
  return queue ? merge(queue, item) : item;
}
