#include <limits.h>
#include "../strawberry_fields.h"

int sf_bounding_box_from_input(const struct sf_input *input,
                               struct sf_interval2 *box) {
  *box = (struct sf_interval2){{INT_MAX, INT_MIN}, {INT_MAX, INT_MIN}};
  int n = 0;
  for (int i = 0; i < SF_LENGTH_MAX; i++) {
    for (int j = 0; j < SF_WIDTH_MAX; j++) {
      if (input->field[i][j] != SF_STRAWBERRY) {
        continue;
      }
      if (i < box->i.min) {
        box->i.min = i;
      }
      if (i >= box->i.max) {
        box->i.max = i + 1;
      }
      if (j < box->j.min) {
        box->j.min = j;
      }
      if (j >= box->j.max) {
        box->j.max = j + 1;
      }
      n++;
    }
  }
  return n;
}
