#include "../strawberry_fields.h"

void sf_choose_representatives(struct sf_interval2 box,
                               const struct sf_equivalence_relation *relation,
                               const struct sf_point_list *s_list,
                               struct sf_point_list *rep_list) {
  int n = 0;
  if (s_list) {
    for (int k = 0; k < s_list->n_points; k++) {
      struct sf_point p = s_list->point[k];
      struct sf_label *l = relation->label[p.i][p.j];
      if (l->mark != -2) {
        l->mark = -2;
        l->n_non_reps = 0;
        rep_list->point[n++] = p;
      } else {
        l->n_non_reps++;
      }
    }
  } else {
    for (int i = box.i.min; i < box.i.max; i++) {
      for (int j = box.j.min; j < box.j.max; j++) {
        struct sf_point p = (struct sf_point){i, j};
        struct sf_label *l = relation->label[p.i][p.j];
        if (l->mark != -2) {
          l->mark = -2;
          rep_list->point[n++] = p;
        }
      }
    }
  }
  rep_list->n_points = n;
}
