#include "../strawberry_fields.h"

void sf_label_equivalence_classes(struct sf_interval2 box,
                                  struct sf_greenhouse_list solution,
                                  struct sf_equivalence_relation *relation) {
  struct sf_label *last = relation->pool;
  last->y = 0.0;
  last->mark = -1;
  last->n_non_reps = (box.i.max - box.i.min) * (box.j.max - box.j.min) - 1;
  for (int i = box.i.min; i < box.i.max; i++) {
    for (int j = box.j.min; j < box.j.max; j++) {
      relation->label[i][j] = last;
    }
  }
  struct sf_label *top = NULL;
  for (int k = 0; k < solution.n_greenhouses; k++) {
    struct sf_interval2 g = solution.greenhouse[k];
    for (int i = g.i.min; i < g.i.max; i++) {
      for (int j = g.j.min; j < g.j.max; j++) {
        struct sf_label *l = relation->label[i][j], *m;
        if (l->mark == k) {
          m = l->next;
          m->n_non_reps++;
        } else {
          if (top) {
            m = top;
            top = m->next;
          } else {
            m = ++last;
          }
          m->y = 0.0;
          l->next = m;
          m->mark = l->mark = k;
          m->n_non_reps = 0;
        }
        relation->label[i][j] = m;
        if (l->n_non_reps) {
          l->n_non_reps--;
        } else {
          l->next = top;
          top = l;
        }
      }
    }
  }
}
