#include "../epsilon.h"
#include "../strawberry_fields.h"

struct sf_greenhouse_list sf_partition(struct sf_node *node,
                                       double upper_bound,
                                       struct sf_greenhouse_list list) {
  struct sf_point p = node->parent->p, q = node->parent->q;
  double gap = (1.0 + epsilon()) * upper_bound - node->super.key;
  int n = list.n_greenhouses;
  for (int k = 0; k < n; ) {
    struct sf_interval2 g = list.greenhouse[k];
    if (sf_point_in_interval2(p, g) + sf_point_in_interval2(q, g) == node->exclude ||
        sf_cost(g) - node->tax - sf_sum(node->y_sum, g) >= gap) {
      n--;
      list.greenhouse[k] = list.greenhouse[n];
      list.greenhouse[n] = g;
    } else {
      k++;
    }
  }
  return (struct sf_greenhouse_list){n, list.greenhouse};
}
