#include <assert.h>
#include <string.h>
#include "../strawberry_fields.h"

static int read_input(FILE *stream, struct sf_input *input) {
  int n;
  if (fscanf(stream, "%d ", &n) < 1) {
    return 0;
  }
  assert(n >= 1);
  memset(input, '\0', sizeof *input);
  input->n_greenhouses_max = n;
  int i = 0, j = 0;
  while (1) {
    int c = getc(stream);
    switch (c) {
    case '\n':
      if (!j) {
      case EOF:
        return 1;
      }
      j = 0;
      i++;
      break;
    case '.':
    case SF_STRAWBERRY:
      assert(i < SF_LENGTH_MAX);
      assert(j < SF_WIDTH_MAX);
      input->field[i][j++] = (char)c;
      break;
    }
  }
}

int sf_read_input(FILE *stream, struct sf_input *input) {
  int n = read_input(stream, input);
  if (ferror(stream)) {
    perror(NULL);
    assert(0);
  }
  return n;
}
