#include <limits.h>
#include "../strawberry_fields.h"

int sf_select_branch(struct sf_interval2 box,
                     struct sf_greenhouse_list solution,
                     struct sf_node *node) {
  struct sf_equivalence_relation relation;
  sf_label_equivalence_classes(box, solution, &relation);
  struct sf_point_list rep_list;
  sf_choose_representatives(box, &relation, NULL, &rep_list);
  int best0 = 0, best1 = INT_MAX;
  for (int i = 0; i < rep_list.n_points; i++) {
    struct sf_point p = rep_list.point[i];
    for (int j = 0; j < rep_list.n_points; j++) {
      struct sf_point q = rep_list.point[j];
      int count[3] = {0, 0, 0};
      for (int k = 0; k < solution.n_greenhouses; k++) {
        struct sf_interval2 g = solution.greenhouse[k];
        count[sf_point_in_interval2(p, g) + sf_point_in_interval2(q, g)]++;
      }
      int score0 = count[1] < count[2] ? count[1] : count[2], score1 = count[1] + count[2];
      if (score0 > best0 || (score0 == best0 && score1 > best1)) {
        best0 = score0;
        best1 = score1;
        node->p = p;
        node->q = q;
      }
    }
  }
  return best0;
}
