#include <assert.h>
#include <string.h>
#include "../strawberry_fields.h"

void sf_verify_solution(const struct sf_input *input,
                        struct sf_greenhouse_list solution) {
  assert(solution.n_greenhouses >= 0);
  assert(solution.n_greenhouses <= input->n_greenhouses_max);
  int coverage[SF_LENGTH_MAX][SF_WIDTH_MAX];
  memset(&coverage, '\0', sizeof coverage);
  for (int k = 0; k < solution.n_greenhouses; k++) {
    struct sf_interval2 g = solution.greenhouse[k];
    for (int i = g.i.min; i < g.i.max; i++) {
      for (int j = g.j.min; j < g.j.max; j++) {
        coverage[i][j]++;
      }
    }
  }
  for (int i = 0; i < SF_LENGTH_MAX; i++) {
    for (int j = 0; j < SF_WIDTH_MAX; j++) {
      assert(coverage[i][j] <= 1);
      assert(input->field[i][j] != SF_STRAWBERRY || coverage[i][j] >= 1);
    }
  }
}
