#include <assert.h>
#include <string.h>
#include "../strawberry_fields.h"

void sf_write_solution(const struct sf_input *input,
                       struct sf_greenhouse_list solution,
                       FILE *stream) {
  static const char letter[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
  assert(solution.n_greenhouses <= (int)sizeof letter - 1);
  int cost = 0;
  char field[SF_LENGTH_MAX][SF_WIDTH_MAX];
  memcpy(field, input->field, sizeof field);
  for (int k = 0; k < solution.n_greenhouses; k++) {
    struct sf_interval2 g = solution.greenhouse[k];
    cost += sf_cost(g);
    for (int i = g.i.min; i < g.i.max; i++) {
      for (int j = g.j.min; j < g.j.max; j++) {
        field[i][j] = letter[k];
      }
    }
  }
  fprintf(stream, "%d\n", cost);
  for (int i = 0; i < SF_LENGTH_MAX; i++) {
    if (!*field[i]) {
      break;
    }
    fprintf(stream, "%.*s\n", SF_WIDTH_MAX, field[i]);
  }
  putc('\n', stream);
  if (ferror(stream)) {
    perror(NULL);
    assert(0);
  }
}
